package ca.recrown.islandsurvivalcraft.world;

import java.util.HashMap;
import java.util.Random;

import org.bukkit.World;

import ca.recrown.islandsurvivalcraft.world.generation.IslandBiomeGenerator;
import ca.recrown.islandsurvivalcraft.world.generation.IslandWorldGenerator;

/**
 * Alternates the data used on a per world basis.
 * Uses IslandWorldGenerator as the container for each world.
 */
public class IslandWorldGeneratorAlternator {
    private HashMap<Long, IslandWorldGenerator> chunkGenerator;
    private IslandBiomeGenerator islandBiomeGenerator;

    public IslandWorldGeneratorAlternator(IslandBiomeGenerator biomeGenerator) {
        chunkGenerator = new HashMap<>();
        this.islandBiomeGenerator = biomeGenerator;
    }

    public synchronized IslandWorldGenerator getIslandChunkGeneratorSystem(World world, Random random) {
        long tid = Thread.currentThread().getId();
        if (!chunkGenerator.containsKey(tid)) {
            chunkGenerator.put(tid, new IslandWorldGenerator(world, islandBiomeGenerator.getInstance(), random));
        }
        return chunkGenerator.get(tid);
    }
}